*======================================================================*;
/*

SAS[U[2016

Kaplan-MeiervbgEForestvbg쐬̉pF
Oto͔͈͓E͈͊Oւ̐lo

Program : Forest.sas
Made by : Ryuji Uozumi
Date : 2016/06/13

*/
*======================================================================*;

*=====================================================*;
* MACRO: ForestTTE ;
*=====================================================*;
* TuO[v͂уtHXgvbgp̃f[^Zbg쐬
*=====================================================*;
* ̐ ;
* data  : ͑Ώۃf[^Zbg ;
* sub   : TuO[v\JeSϐ ;
* varname   : tHXgvbgɎTuO[v ;
* format   : TuO[ṽJeS (Oɒ`) tH[}bg ;
* grp   : Q\ϐ (grp = 2 ΏƌQƂ) ;
* tte : Ԃ̕]ڂ\ϐ ;
* censor : ł؂\ϐ ;
* censorval : ł؂l ;
* num   : TuO[vɕt^ʒl ;
* out   : o̓f[^Zbg ;
*=====================================================*;

%macro ForestTTE(data,sub,varname,format,grp,tte,censor,censorval,num,out);

proc sort data=&data out=data00;
  by &sub;
run;

*-------------------------------------------------------;
* eQ̃CxǧvZ ;

ods listing close;
ods output CensoredSummary=event00;
proc lifetest data=data00;
  time &tte*&censor(&censorval);
  strata &grp;
  by &sub;
run;
ods listing;

data event00;set event00;
  where &grp in(1,2);
  N=Total;
  Event=Failed;
  prop=Failed/Total;
  pevent=trim(left(put(cat(trim(left(Event)),
               "/",
               trim(left(N)),
               " (",
               trim(left(put(
                 round(prop*100,1e-1),8.1
               ))),
               ")"),20.)));
  keep &grp &sub pevent;
run;

proc transpose data=event00 out=event00;
  id &grp;
  by &sub;
  var pevent;
run;

data event00;set event00;
  rename _1=grp1
         _2=grp2
  ;
  drop _NAME_;
run;

*-------------------------------------------------------;
* eTuO[vɂᐔ̌vZ ;

ods listing close;
ods output CensoredSummary=total00;
proc lifetest data=data00;
  time &tte*&censor(&censorval);
  by &sub;
run;
ods listing;

data total00;set total00;
  N=Total;
  Event=Failed;
  keep &sub N Event;
run;

*-------------------------------------------------------;
* nU[ȟvZ ;

ods listing close;
ods output ParameterEstimates=HR00;
proc phreg data=data00;
  class &grp(ref="2");
  model &tte*&censor(&censorval) = &grp / rl ties=breslow;
  by &sub;
run;
ods listing;

data HR00;set HR00;
  where Parameter="&grp";
  HR=trim(left(put(cat(
               trim(left(put(
                 round(HazardRatio,1e-2),8.2
               ))),
               " (",
               trim(left(put(
                 round(HRLowerCL,1e-2),8.2
               ))),
               "-",
               trim(left(put(
                 round(HRUpperCL,1e-2),8.2
               ))),
               ")"),20.)));
  keep &sub HazardRatio HRLowerCL HRUpperCL HR;
run;

*-------------------------------------------------------;
* ݍppľvZ ;

ods listing close;
/* SAS/STAT14.1ɑΉ, STAT/STAT13.2ȑOłModelANOVȂType3w */
ods output ModelANOVA=int00;
proc phreg data=data00;
  class &grp(ref="2") &sub;
  model &tte*&censor(&censorval) = &grp &sub &grp*&sub / rl ties=breslow;
run;
ods listing;

data int00;set int00;
  where Effect="&grp*&sub";
  intpval=trim(left(put(round(ProbChiSq,1e-3),pvalue8.3)));
  subgroup=&varname;
  subgroupc=&num;
  keep subgroup subgroupc intpval;
run;

*-------------------------------------------------------;
* ׂĂ̌vZʂW ;

data surv00;
  merge total00 event00 HR00;
  by &sub;
  &grp=1;
data surv00;set surv00;
  where &sub^=.;
run;

data surv00;set surv00;
  subgroupc=&num;
  subgroup=put(&sub,&format);
  catc=&sub;
run;

data item00;set int00;
  valtype=1;
data cat00;set surv00;
  valtype=2;
  if &varname="Overall" then valtype=1;
data &out;
  length subgroup $ 50;
  set item00 cat00;
  drop &sub &grp;
run;

%mend ForestTTE;

*==================================================*;
* TuO[vƂɉ͎s ;
*==================================================*;

%ForestTTE(VALung,all,"Overall",Allf.,Therapy2,Time,Censor,1,0,all);
%ForestTTE(VALung,AgeC,"Age",AgeCf.,Therapy2,Time,Censor,1,1,age);
%ForestTTE(VALung,CellC,"Cell",Cellf.,Therapy2,Time,Censor,1,2,cell);
%ForestTTE(VALung,Prior,"Prior",Priorf.,Therapy2,Time,Censor,1,3,prior);

*==================================================*;
* TuO[v͌ʂ̏W ;

data forestdata00;
  length subgroup $ 50;
  set all age cell prior
  ;
run;

*==================================================*;
* Ŝ̉͌ʂ}NŎ{ʂ̒ ;

data forestdata00;set forestdata00;
  if subgroupc=0 and N=. then delete;
run;

*==================================================*;
* Cfg̐ݒ ;

data forestdata00;set forestdata00;
  forestval=_n_;
  if mod(subgroupc,2)^=0 then ref=forestval;
  indent=1;
  if subgroup="Overall" or intpval^="" then indent=0;
run;

ods listing close;
ods output summary=forestvalmax;
proc means data=forestdata00 max;
  var forestval;
run;
ods listing;

*==================================================*;
* ̐eLXg̐ݒ ;

data xaxis;
  length text $ 50;
  set forestvalmax;
  forestval=forestval_Max+1;
  valtype=2;
  xl=0.2; yl=forestval; text='<-- Test Better'; output;
  xl=4; yl=forestval; text='Standard Better -->'; output;
run;

data forestdata;
  set forestdata00 xaxis;
run;

*==================================================*;
* ϐx̎w ;

data forestdata;set forestdata;
  label grp1="No. of Patients in Test Group (%)"
        grp2="No. of Patients in Standard Group (%)"
        intpval="P-value for Interaction"
		subgroup="Subgroup"
		HR="@"
  ;
run;

*==================================================*;
* t^D̃f[^ZbgATTRMAP쐬vO ;

data attrmap;
  length textweight $10;
  id='text'; value='1'; textcolor='Black'; textsize=7; textweight='bold'; output;
  id='text'; value='2'; textcolor='Black'; textsize=5; textweight='normal'; output;
run;

*==================================================*;
* }5 ;
*==================================================*;

ods listing close;
ods html image_dpi=400 style=analysis;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=forestdata noautolegend;
  refline ref / axis=y lineattrs=(thickness=30 color=cxf0f0f0);
  scatter y=forestval x=HazardRatio 
   / errorbarattrs=(thickness=1 color=blue) 
     xerrorupper=HRUpperCL xerrorlower=HRLowerCL 
     markerattrs=(size=0);
  bubble y=forestval x=HazardRatio size=N 
   / bradiusmax=4.2 bradiusmin=0.2
     fillattrs=(color=blue) lineattrs=(color=blue);
  refline 1 / axis=x lineattrs=(pattern=shortdash) transparency=0.5;                                                              
  xaxis type=log minor min=0.1 max=5 display=(nolabel) valueattrs=(size=7);
  yaxis display=none;
run;
ods graphics off;
ods html close;
ods listing;

*==================================================*;
* }6, 7 ;
*==================================================*;

ods listing close;
ods html image_dpi=400 style=analysis;
ods graphics / reset noborder noscale
               width=600px height=300px
               imagefmt=png
;
proc sgplot data=forestdata dattrmap=attrmap nowall noborder nocycleattrs noautolegend;
  styleattrs axisextent=data;
  refline ref / axis=y lineattrs=(thickness=13 color=cxf0f0f0);
  scatter y=forestval x=HazardRatio 
    / errorbarattrs=(thickness=1 color=blue)
      xerrorupper=HRUpperCL xerrorlower=HRLowerCL
      markerattrs=(size=0);
  bubble y=forestval x=HazardRatio size=N
   / bradiusmax=4.2 bradiusmin=0.2
     fillattrs=(color=blue) lineattrs=(color=blue);
  scatter y=forestval x=HazardRatio / markerattrs=(size=0) x2axis;
  refline 1 / axis=x lineattrs=(pattern=shortdash) transparency=0.5;                                                              
  text x=xl y=forestval text=text / position=center contributeoffsets=none;
  yaxistable subgroup  / location=inside position=left
             textgroup=valtype labelattrs=(size=8) 
			 labeljustify=left
			 titlejustify=left
             textgroupid=text indentweight=indent;
  yaxistable grp1 grp2 / location=inside position=left labelattrs=(size=8) valueattrs=(size=7)
             valuehalign=center
             valuejustify=right;
  yaxistable HR intpval / location=inside position=right labelattrs=(size=8) 
             valueattrs=(size=7) valuehalign=center;
  yaxis reverse display=none colorbands=odd colorbandsattrs=(transparency=1) offsetmin=0.1;
  xaxis type=log values=(0.2 0.5 2 5) minor display=(nolabel) valueattrs=(size=7);
  x2axis label='Hazard Ratio (95% CI)'
         display=(noline noticks novalues) labelattrs=(size=8);
run;
ods graphics off;
ods html close;
ods listing;

*==================================================*;
* }6, 8 ;
*==================================================*;

ods listing close;
ods html image_dpi=400 style=analysis;
ods graphics / reset noborder noscale
               width=600px height=300px
               imagefmt=png
;
proc sgplot data=forestdata dattrmap=attrmap nowall noborder nocycleattrs noautolegend;
  styleattrs axisextent=data;
  refline ref / axis=y lineattrs=(thickness=13 color=cxf0f0f0);
  highlow y=forestval low=HRLowerCL high=HRUpperCL
   / lineattrs=(color=blue); 
  bubble y=forestval x=HazardRatio size=N
   / bradiusmax=4.2 bradiusmin=0.2
     fillattrs=(color=blue) lineattrs=(color=blue);
  scatter y=forestval x=HazardRatio / markerattrs=(size=0) x2axis;
  refline 1 / axis=x lineattrs=(pattern=shortdash) transparency=0.5;                                                              
  text x=xl y=forestval text=text / position=center contributeoffsets=none;
  yaxistable subgroup  / location=inside position=left
             textgroup=valtype labelattrs=(size=8) 
			 labeljustify=left
			 titlejustify=left
             textgroupid=text indentweight=indent;
  yaxistable grp1 grp2 / location=inside position=left labelattrs=(size=8) valueattrs=(size=7)
             valuehalign=center
             valuejustify=right;
  yaxistable HR intpval / location=inside position=right labelattrs=(size=8) 
             valueattrs=(size=7) valuehalign=center;
  yaxis reverse display=none colorbands=odd colorbandsattrs=(transparency=1) offsetmin=0.1;
  xaxis type=log values=(0.2 0.5 2 5) minor display=(nolabel) valueattrs=(size=7);
  x2axis label='Hazard Ratio (95% CI)'
         display=(noline noticks novalues) labelattrs=(size=8);
run;
ods graphics off;
ods html close;
ods listing;

*==================================================*;
* END ;
*==================================================*;

