*======================================================================*;
/*

SAS[U[2016

Kaplan-MeiervbgEForestvbg쐬̉pF
Oto͔͈͓E͈͊Oւ̐lo

Program : KM.sas
Made by : Ryuji Uozumi
Date : 2016/06/11

*/
*======================================================================*;

*==================================================*;
* }1 ;
*==================================================*;

ods html image_dpi=400 style=journal;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
ods listing close;
proc lifetest data=VALung plots=s(atrisk atrisktick);
  time Time*Censor(1);
  strata Cell;
run;
ods listing;
ods graphics off;
ods html close;

*==================================================*;
* }2 ;
*==================================================*;

*==================================================*;
* XNW̏o͎ԊԊu ;

%let TimeInterval=200;

*==================================================*;
* XNW̏o͍ő厞 ;

%let TimeMax=1000;

*==================================================*;
* f[^ZbgSurvivalplotSurvivalplot2̍쐬 ;

ods listing close;
ods graphics;
ods output Survivalplot=Survivalplot;
proc lifetest data=VALung atrisk plots=s(atrisk=0 to &TimeMax by &TimeInterval);
  time Time*Censor(1);
  strata Cell;
run;

data form;
do StratumNum=1 to 4;
  do time=0 to &TimeMax by &TimeInterval;
    output;
  end;
end;
run;

data atrisk0;
  merge form Survivalplot;
  by StratumNum time;
run;

data Survivalplot2;set atrisk0;
  if AtRisk=. then do;
    AtRisk=0;
    tAtRisk=time;
  end;
run;

ods html image_dpi=400 style=journal;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
ods listing close;
proc sgplot data=Survivalplot2 noautolegend;
  step x=Time y=Survival / group=StratumNum name='Survival';
  scatter x=Time y=Censored / group=StratumNum markerattrs=(symbol=plus);
  scatter x=tAtRisk y=StratumNum / markerchar=atrisk y2axis;
  keylegend 'Survival' / location=outside noborder position=bottom;
  yaxis offsetmin=0.20 values=(0 to 1 by 0.1) label='Survival';
  y2axis offsetmin=0.03 offsetmax=0.85 min=1 max=4 label='@' display=(noticks novalues);
  xaxis offsetmin=0.05 values=(0 to &TimeMax by &TimeInterval) label='Time';
  format StratumNum Cellf.;
run;
ods listing;
ods graphics off;
ods html close;

*==================================================*;
* }3 ;
*==================================================*;

ods html image_dpi=400 style=journal;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
ods listing close;
proc sgplot data=Survivalplot2 noautolegend;
  step x=Time y=Survival / group=StratumNum name='Survival';
  scatter x=Time y=Censored / group=StratumNum markerattrs=(symbol=plus);
  xaxistable AtRisk / x=tAtRisk class=StratumNum;
  keylegend 'Survival' / location=outside noborder position=bottom;
  yaxis values=(0 to 1 by 0.1) label='Survival';
  xaxis values=(0 to &TimeMax by &TimeInterval) label='Time';
  format StratumNum Cellf.;
run;
ods listing;
ods graphics off;
ods html close;

*==================================================*;
* }4 ;
*==================================================*;

ods html image_dpi=400 style=journal;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
ods listing close;
proc lifetest data=VALung plots=s(atrisk atrisktick);
  time Time*Censor(1);
  strata Cell;
run;
proc lifetest data=VALung plots=s(atrisk atrisktick outside);
  time Time*Censor(1);
  strata Cell;
run;
ods listing;
ods graphics off;
ods html close;

*==================================================*;
* END ;
*==================================================*;
